//
//  ARMView.m
//  GLTest2
//
//  Created by nsato on 09/05/06.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "ARMView.h"
#include <math.h>

#define PI 3.14159263

@implementation ARMView

@synthesize firstTouch;
@synthesize lastTouch;
@synthesize endTouch;
@synthesize currentColor;
//@synthesize rectSeq;
@synthesize context;
@synthesize myArray;
@synthesize myColorArray;
//@synthesize myWayPointArray;
//@synthesize myWayColorArray;
@synthesize testFlag;
@synthesize velValue;
@synthesize textSt;
@synthesize pointNumber;

@synthesize testLogWayPointNorthArray;
@synthesize testLogWayPointEastArray;

@synthesize startDisplayFlag;


-(BOOL) isMultipleTouchEnabled{
	return true;
}

- (void) touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event{
//	self.currentColor=[UIColor redColor];

	
	UITouch *touch =[touches anyObject];
	firstTouch = [touch locationInView:self];
	lastTouch = [touch locationInView:self];
	[self setNeedsDisplay];
}

- (void) touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event{
	UITouch *touch =[touches anyObject];
	lastTouch = [touch locationInView:self];
//	if(modeFlag==1){	//waypointモードのとき
//		endTouch = [touch locationInView:self];
//		pointNumber++;
//		[textSt setText:[NSString stringWithFormat:@"%d",pointNumber]];
//	}else{
		endTouch.x=-100;
		endTouch.y=-100;
//	}
	
	[self setNeedsDisplay];
}


-(void)touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event{
	UITouch *touch =[touches anyObject];
	lastTouch = [touch locationInView:self];
	[self setNeedsDisplay];
}


- (id)initWithFrame:(CGRect)frame {
    if (self = [super initWithFrame:frame]) {
        // Initialization code
		self.backgroundColor = [UIColor whiteColor];
		myArray = [[NSMutableArray alloc] init];
		myColorArray = [[NSMutableArray alloc] init];

    }
    return self;
}


- (void)drawRect:(CGRect)rect {
	
//	UIFont *font;
//	font = [UIFont systemFontOfSize:26.0f];
//	NSString *dispSt=[NSString stringWithFormat:@"Test"];
//	[dispSt drawAtPoint:CGPointMake(50.0f, 100.0f) withFont:font];

	//context取得
	context =UIGraphicsGetCurrentContext();
	//Lineの太さ
	CGContextSetLineWidth(context, 0.0);

	//タッチ点の矩形を作成
	CGRect currentRect = CGRectMake(
									(firstTouch.x > lastTouch.x) ? lastTouch.x : firstTouch.x,
									(firstTouch.y > lastTouch.y) ? lastTouch.y : firstTouch.y,
									fabsf(firstTouch.x - lastTouch.x),
									fabsf(firstTouch.y - lastTouch.y));

	//CGRect lastRect = CGRectMake(lastTouch.x,lastTouch.y,1.0f,1.0f);
//	CGRect endRect = CGRectMake(endTouch.x,endTouch.y,1.0f,1.0f);
	//最初は初期化
	if(!testFlag){
		myArray = [[NSMutableArray alloc] init];
		myColorArray = [[NSMutableArray alloc] init];
//		myWayPointArray = [[NSMutableArray alloc] init];
//		myWayColorArray = [[NSMutableArray alloc] init];
	}
	testFlag=true;

	//regionModeなら矩形データをmyArrayに、色情報をmyColorArrayに入れる
//	if(modeFlag==0){	//領域モードが選ばれている
		//矩形データを配列に入れる
		NSValue *rectValue = [NSValue valueWithCGRect:currentRect];		
		[myArray addObject:rectValue];
		//色データを配列に入れる
		[myColorArray addObject: [NSNumber numberWithFloat:velValue]];
//	}else if(modeFlag==1){	//経由点モードが選ばれている
//		//経由点データを配列に入れる
//		NSValue *endPointValue = [NSValue valueWithCGRect:endRect];		
//		[myWayPointArray addObject:endPointValue];
//		//色データを配列に入れる
//		[myWayColorArray addObject: [NSNumber numberWithFloat:(1.0f-(float)(pointNumber-1)/255.0)]];
//		
//		
//		
//		
//		
//	}else{
//		
//	}
	
	//実際に描画する
	//領域の描画	
	for(int i=0; i<[myArray count];i++){
		//配列からナンバーに対応する色（制限速度）データを取り出す
		float color =0;
		color=[[myColorArray objectAtIndex:i] floatValue]; 
		//色データをセット
		if(color==1.0f){
			self.currentColor=[UIColor colorWithRed:1.0f
											  green:1.0f
											   blue:1.0f
											  alpha:1.0];		
		}else{
			self.currentColor=[UIColor colorWithRed:0.0f
											  green:0.0f
											   blue:color
											  alpha:1.0];		
		}			
		CGContextSetStrokeColorWithColor(context, currentColor.CGColor);
		CGContextSetFillColorWithColor(context, currentColor.CGColor);

		//配列からナンバーに対応する矩形データを取り出す
		NSValue *paintValue =[myArray objectAtIndex:i]; 
		//矩形データをセット
		CGRect paintRect= [paintValue CGRectValue];
		//コンテキストに追加
		CGContextAddRect(context, paintRect);
		//実際に描画
		CGContextDrawPath(context, kCGPathFillStroke);
	}
	if(startDisplayFlag){
		self.currentColor=[UIColor colorWithRed:1.0f
										  green:0.0f
										   blue:0.0f
										  alpha:1.0];		
		CGContextSetStrokeColorWithColor(context, currentColor.CGColor);
		CGContextSetFillColorWithColor(context, currentColor.CGColor);
		//矩形データをセット
		CGRect startPoint = CGRectMake((int)250,(int)150,5.0f,5.0f);
		//コンテキストに追加
		CGContextAddRect(context, startPoint);
		CGRect goalPoint = CGRectMake((int)50,(int)150,5.0f,5.0f);
		//コンテキストに追加
		CGContextAddRect(context, goalPoint);
		//実際に描画
		CGContextDrawPath(context, kCGPathFillStroke);
		
	}
	
	//wayPointはグーグルマップのピンの位置にするので作成部分はコメントアウト
//	//経由点（ウェイポイント）の描画
//	for(int i=0; i<[myWayPointArray count];i++){
//		//配列からナンバーに対応する色（経由点番号）データを取り出す
//		float color =0;
//		color=[[myWayColorArray objectAtIndex:i] floatValue]; 
//		//色データをセット
//		self.currentColor=[UIColor colorWithRed:color
//										  green:0.0f
//										   blue:1.0f
//										  alpha:1.0];		
//		CGContextSetStrokeColorWithColor(context, currentColor.CGColor);
//		CGContextSetFillColorWithColor(context, currentColor.CGColor);
//		
//		//配列からナンバーに対応する矩形データを取り出す
//		NSValue *pointValue =[myWayPointArray objectAtIndex:i]; 
//		//矩形データをセット
//		CGRect wayPoint= [pointValue CGRectValue];
//		//コンテキストに追加
//		CGContextAddRect(context, wayPoint);
//		//CGContextAddRect(context, lastRect);
//		//実際に描画
//		CGContextDrawPath(context, kCGPathFillStroke);
//	}		
	
	
	//ログWayPointデータの表示
	if(testLogWayPointEastArray != nil && testLogWayPointNorthArray !=nil){
		for(int i=0; i<[testLogWayPointEastArray count];i++){
			//色データをセット
			float tempRedColor=1.0f-(1.0/255.0)*i;
			self.currentColor=[UIColor colorWithRed:tempRedColor
											  green:0.0f
											   blue:1.0f
											  alpha:1.0];		
			CGContextSetStrokeColorWithColor(context, currentColor.CGColor);
			CGContextSetFillColorWithColor(context, currentColor.CGColor);
			
			//配列からナンバーに対応する矩形データを取り出す
			NSString *eastPixelSt=[testLogWayPointEastArray objectAtIndex:i];
			NSString *northPixelSt=[testLogWayPointNorthArray objectAtIndex:i];
			double eastPixel=[eastPixelSt doubleValue];
			double northPixel=[northPixelSt doubleValue];
			

			if(!startDisplayFlag){
				//矩形データをセット
				CGRect logWayPoint = CGRectMake((int)eastPixel,(int)northPixel,1.0f,1.0f);
				//コンテキストに追加
				CGContextAddRect(context, logWayPoint);
				//CGContextAddRect(context, lastRect);
				//実際に描画
				CGContextDrawPath(context, kCGPathFillStroke);
			}
		}		
		
		
		
	}
	
	
//	context =UIGraphicsGetCurrentContext();
//	//start point
//	//stroke
//	CGContextSetRGBStrokeColor(context, 0.0, 0.0, 0.0,1.0);
//	CGContextSetRGBFillColor(context, 1.0, 1.0, 1.0, 1.0);
//	CGContextSetLineWidth(context, 1.0);
//	//line
//	CGContextStrokeEllipseInRect(context, CGRectMake(150.0, 150.0, 1.0, 1.0));
//	
//	//paint
//	CGContextStrokePath(context);
	
	
/*	
	
	//goal point
	UIColor *goalColor=[UIColor colorWithRed:(127.0f / 255.0f)
										green:0.0
										 blue:0.0
										alpha:1.0];
	CGContextSetStrokeColorWithColor(context, goalColor.CGColor);
	CGContextSetFillColorWithColor(context, goalColor.CGColor);
	CGContextMoveToPoint(context, 150,10);
	CGContextAddLineToPoint(context, 151, 11);
	CGContextStrokePath(context);
*/	
	

//	switch (shapeType) {
//		case kLineShape:
//			CGContextMoveToPoint(context, firstTouch.x, firstTouch.y);
//			CGContextAddLineToPoint(context, lastTouch.x, lastTouch.y);
//			CGContextStrokePath(context);
	
//	CGContextAddRect(context, currentRect);
//	CGContextDrawPath(context, kCGPathFillStroke);
	
//			break;
//		case kRectShape:
//			break;
//		case kEllipseShape:
//			break;
//		case kImageShape:
//			break;
//		default:
//			break;
//	}
	
}

//- (IBAction)barChangeAction:(id)sender{
//	
//	
//	CGFloat r=[barValue floatValue];
//	CGFloat g=[barValue floatValue];
//	CGFloat b=[barValue floatValue];
//	
//	
//	self.currentColor=[UIColor colorWithRed:[barValue floatValue]
//									  green:[barValue floatValue]
//									   blue:[barValue floatValue]
//									  alpha:1.0];
//	self.currentColor=[UIColor colorWithRed:0.0
//									  green:0.0
//									   blue:0.0
//									  alpha:1.0];
//}


- (void)dealloc {
    [super dealloc];
}

- (IBAction)barValueChangeAction:(id)sender{
	velValue=[(UISlider *)sender value];
	[textSt setText:[NSString stringWithFormat:@"%.3f", velValue]];
	
//	self.currentColor=[UIColor colorWithRed:velValue
//									  green:velValue
//									   blue:velValue
//									  alpha:1.0];
	
}

//- (IBAction)modeChangeAction:(id)sender{
//	switch ([paintMode selectedSegmentIndex]) {
//	case 0:	//region
//		modeFlag=0;
////		[textSt setText:[NSString stringWithFormat:@"region"]];
//
//		break;
//	case 1:	//region
//		modeFlag=1;
//			
//			
//			
//			
//			
//		break;
//	default:
//		modeFlag=-1;
//		break;
//	}
//		
//}

@end
