//
//  regionMapViewController.h
//  regionMap
//
//  Created by nsato on 09/08/20.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <MapKit/MKMapView.h>
#import "ARMView.h"
#import <QuartzCore/QuartzCore.h>
#import "MultipartPostHelper.h"
//#import <CoreLocation/CoreLocation.h>

#import "MyAnnotation.h"

@class MultipartPostHelper;


@interface regionMapViewController : UIViewController <CLLocationManagerDelegate, MKMapViewDelegate, UIPickerViewDelegate>{
	CLLocationManager *locationManager;

	IBOutlet MKMapView *mapview;
	IBOutlet ARMView *imageview;
	IBOutlet UIProgressView* activeMark;
	
	IBOutlet NSMutableArray* logWayPointNorthArray;
	IBOutlet NSMutableArray* logWayPointEastArray;

	IBOutlet UIPickerView* picker;

	IBOutlet id switchState;
	IBOutlet id switchState2;
	IBOutlet id placeSt;
	IBOutlet id modeLabel;
	IBOutlet id urlSt;
	IBOutlet id compassLabel;
	IBOutlet id testButton;
	IBOutlet id modeButton;
	
	bool mapFirstLook;
	
	double widthMeterPixel;
	double hightMeterPixel;	
	int modeNumber;
	int uploadCount;
	int testCount;	
}

@property (nonatomic, retain) IBOutlet MKMapView *mapview;
@property (nonatomic, retain) IBOutlet ARMView *imageview;
@property (nonatomic, retain) IBOutlet id switchState;
@property (nonatomic, retain) IBOutlet id switchState2;
@property (nonatomic, retain) CLLocationManager *locationManager;
@property (nonatomic, retain) IBOutlet NSMutableArray* logWayPointNorthArray;
@property (nonatomic, retain) IBOutlet NSMutableArray* logWayPointEastArray;
@property (nonatomic, retain) IBOutlet UIPickerView* picker;
@property (nonatomic, retain) IBOutlet id placeSt;
@property (nonatomic, retain) IBOutlet UIProgressView* activeMark;
@property (nonatomic, retain) IBOutlet id modeButton;
@property (nonatomic, retain) IBOutlet id modeLabel;
//@property (nonatomic, retain) IBOutlet UIPickerView* picker2;
@property (nonatomic, retain) IBOutlet id urlSt;
@property (nonatomic, retain) IBOutlet id compassLabel;

//@property (nonatomic, retain) IBOutlet id slideValue;
//@property (nonatomic, retain) IBOutlet id textSt;
@property (nonatomic, retain) IBOutlet id testButton;


//- (IBAction)opushButton0:(id)sender;
- (IBAction)switchButton:(id)sender;
- (IBAction)button0:(id)sender;
- (IBAction)saveViewsAndText:(id)sender;
- (IBAction)modeButtonTouchDown:(id)sender;
//- (IBAction)barChangeAction:(id)sender;

-(IBAction)upload:(id)sender;
- (void)addSomeAnnotations:(NSString*)filename;

-(NSData *)getUploadFile;
-(NSData *)getUploadMapFile;
-(NSData *)getUploadPixelFile;
-(NSData *)getUploadTestFile;
- (IBAction)placeStart:(id)sender;
- (IBAction)placeEnd:(id)sender;
//- (IBAction)urlStart:(id)sender;
//- (IBAction)urlEnd:(id)sender;

- (double) hubeny: (double) latitudeB latitudeA: (double) latitudeA latitudeDeltaH: (double) latitudeDeltaH longitudeDeltaH: (double) longitudeDeltaH;
- (void) calcPixel;
-(void)progress:(NSNumber*)amount;

- (NSString*) makeFileName:(NSString*)fileNameOriginal;
-(IBAction)testAction:(id)sender;


@end

