//
//  regionMapViewController.m
//  regionMap
//
//  Created by nsato on 09/08/20.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import "regionMapViewController.h"


@implementation regionMapViewController

@synthesize mapview;
@synthesize imageview;
@synthesize switchState;
@synthesize switchState2;
@synthesize locationManager;
@synthesize logWayPointNorthArray;
@synthesize logWayPointEastArray;
@synthesize picker;
@synthesize placeSt;
@synthesize activeMark;
@synthesize modeButton;
@synthesize modeLabel;
//@synthesize picker2;
@synthesize urlSt;
@synthesize compassLabel;
@synthesize testButton;

- (double) hubeny: (double) latitudeB latitudeA: (double) latitudeA latitudeDeltaH: (double) latitudeDeltaH longitudeDeltaH: (double) longitudeDeltaH  {
	//ヒュベニの公式から表示地図の横幅が何mかを算出
	//http://www.kashmir3d.com/kash/manual/std_siki.htm
	double D=0.0;	//２点の距離[m]
	double P=(M_PI/180.0*latitudeA+M_PI/180.0*latitudeB)/2.0;	//２点の平均緯度[rad]
	double dP=M_PI/180.0*latitudeDeltaH;	//２点の緯度差[rad]
	double dR=M_PI/180.0*longitudeDeltaH;	//２点の経度差[rad]
	//日本測地系
	//	double A=1-0.006674*sin(P)*sin(P);
	//	double M=6334834/sqrt(A*A*A);	//子午線曲率半径
	//	double N=6377397/sqrt(A);	//卯酉線曲率半径
	
	//世界測地系
	double A=1.0-0.00669438*sin(P)*sin(P);
	double M=6335439.0/sqrt(A*A*A);	//子午線曲率半径
	double N=6378137.0/sqrt(A);	//卯酉線曲率半径
	
	D=sqrt((M*dP)*(M*dP)+(N*cos(P)*dR)*(N*cos(P)*dR));
	return D;
}

- (void) pickerView: (UIPickerView*)pView didSelectRow:(NSInteger) row  inComponent:(NSInteger)component {  
}  

- (NSInteger) numberOfComponentsInPickerView:(UIPickerView *)pickerView {  
    return 1;  
}  

- (NSInteger) pickerView: (UIPickerView*)pView numberOfRowsInComponent:(NSInteger) component {  
    return 5;
}  

- (NSString*)pickerView: (UIPickerView*) pView titleForRow:(NSInteger) row forComponent:(NSInteger)component {  
	if(row==0){
		return [NSString stringWithFormat:@"Tsukuba"];  
	}else if(row==1){
		return [NSString stringWithFormat:@"Kyoto"];  
	}else if(row==2){
		return [NSString stringWithFormat:@"UEC"];  
	}else if(row==3){
		return [NSString stringWithFormat:@"NEDO Stage"];  
	}else if(row==4){
		return [NSString stringWithFormat:@"RT Plaza"];  
	}else{
		return [NSString stringWithFormat:@"%d - %d",component, row];  
	}
} 

//- (IBAction)urlStart:(id)sender{
////	picker2.hidden=NO;
//}

//- (IBAction)urlEnd:(id)sender{
////	picker2.hidden=YES;
////	[sender resignFirstResponder];
////	NSString* picker2St;
////    int row = [picker2 selectedRowInComponent:0];  
////	if(row==0){
////		picker2St=[NSString stringWithFormat:@"satolab"];
////		[urlSt setText:picker2St];
////	}else if(row==1){
////		picker2St=[NSString stringWithFormat:@"TypeP"];
////		[urlSt setText:picker2St];
////	}
////	
//}

- (IBAction)placeStart:(id)sender{
	picker.hidden=NO;
}

- (IBAction)placeEnd:(id)sender{
	picker.hidden=YES;
	[sender resignFirstResponder];
	NSString* pickerSt;
    int row = [picker selectedRowInComponent:0]; 
	if(row==0){
		mapview.hidden=NO;
		pickerSt=[NSString stringWithFormat:@"Tsukuba"];
		[placeSt setText:pickerSt];
		imageview.alpha=0.5;
		
		//画像の中心をつくチャレコースにする
		MKCoordinateRegion zoom;
		zoom.center.latitude =36.086;
		zoom.center.longitude=140.11;
		
		zoom.span.latitudeDelta = 0.0013;
		zoom.span.longitudeDelta = 0.0013;
		[mapview setRegion:zoom animated:NO];
		
		[self calcPixel];
		logWayPointNorthArray = nil;
		logWayPointEastArray = nil;
		imageview.testLogWayPointEastArray=nil;
		imageview.testLogWayPointNorthArray=nil;
		[self addSomeAnnotations:@"GPS_LOG"];
		[imageview setNeedsDisplay];
		[mapview setRegion:zoom animated:YES];

	}else if(row==1){
		mapview.hidden=NO;
		pickerSt=[NSString stringWithFormat:@"Kyoto"];
		[placeSt setText:pickerSt];
		imageview.alpha=0.5;
		
		//画像の中心を京都大学にする
		MKCoordinateRegion zoom;
		zoom.center.latitude =35.026262505;
		zoom.center.longitude=135.78343033;
		
		zoom.span.latitudeDelta = 0.0013;
		zoom.span.longitudeDelta = 0.0013;
		[mapview setRegion:zoom animated:NO];
		
		[self calcPixel];
		
		logWayPointNorthArray = nil;
		logWayPointEastArray = nil;
		imageview.testLogWayPointEastArray=nil;
		imageview.testLogWayPointNorthArray=nil;

		[self addSomeAnnotations:@"GPS_LOG2"];
		[imageview setNeedsDisplay];
		[mapview setRegion:zoom animated:YES];
		
	}else if(row==2){
		mapview.hidden=NO;
		pickerSt=[NSString stringWithFormat:@"UEC"];
		[placeSt setText:pickerSt];
		imageview.alpha=0.5;
		
		//画像の中心を電通大にする
		MKCoordinateRegion zoom;
		zoom.center.latitude =35.6577;
		zoom.center.longitude=139.5446;
		
		zoom.span.latitudeDelta = 0.0013;
		zoom.span.longitudeDelta = 0.0013;
		[mapview setRegion:zoom animated:NO];
		
		[self calcPixel];
		
		logWayPointNorthArray = nil;
		logWayPointEastArray = nil;
		imageview.testLogWayPointEastArray=nil;
		imageview.testLogWayPointNorthArray=nil;
		
		[self addSomeAnnotations:@"GPS_LOG3"];
		[imageview setNeedsDisplay];
		[mapview setRegion:zoom animated:YES];
		
	}else if(row==3){
		mapview.hidden=YES;
		pickerSt=[NSString stringWithFormat:@"NEDO Stage"];
		[placeSt setText:pickerSt];
		imageview.alpha=1.0;
		imageview.startDisplayFlag=true;
		[imageview setNeedsDisplay];
	}else if(row==4){
		mapview.hidden=YES;
		pickerSt=[NSString stringWithFormat:@"RT Plaza"];
		[placeSt setText:pickerSt];
		imageview.alpha=1.0;
		imageview.startDisplayFlag=true;
		[imageview setNeedsDisplay];
	}else{
		pickerSt=[NSString stringWithFormat:@"error"];
		[placeSt setText:pickerSt];
		imageview.alpha=0.5;

		//画像の中心をつくチャレコースにする
		MKCoordinateRegion zoom;
		zoom.center.latitude =36.086;
		zoom.center.longitude=140.11;
		
		zoom.span.latitudeDelta = 0.0013;
		zoom.span.longitudeDelta = 0.0013;
		[mapview setRegion:zoom animated:YES];
	}
}

/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/
/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

- (void) calcPixel {
	//緯度経度をログに出す（デバグ用）
//	  NSString *getregion=[NSString stringWithFormat:@""];

	//表示しているマップの緯度経度の中心座標を取得
	double latitude=mapview.region.center.latitude;
	double longitude=mapview.region.center.longitude;
	//捧持しているマップの緯度経度の角度幅を取得
	double latitudeDelta=mapview.region.span.latitudeDelta;
	double longitudeDelta=mapview.region.span.longitudeDelta;
	
	//表示マップの四隅の緯度経度を算出
	double latitudeLU=latitude+latitudeDelta/2.0;
	double latitudeRU=latitude+latitudeDelta/2.0;
	double latitudeLB=latitude-latitudeDelta/2.0;
//	double latitudeRB=latitude-latitudeDelta/2.0;
	
	double longitudeLU=longitude-longitudeDelta/2.0;
	double longitudeRU=longitude+longitudeDelta/2.0;
	double longitudeLB=longitude-longitudeDelta/2.0;
//	double longitudeRB=longitude+longitudeDelta/2.0;

	//横幅をヒュベニの公式から算出
	double latitudeA=latitudeLU;
	double latitudeB=latitudeRU;
	double latitudeDeltaH=latitudeLU-latitudeRU;
	double longitudeDeltaH=longitudeLU-longitudeRU;
	
	double widthMeter=[self hubeny: latitudeB 
						 latitudeA: latitudeA 
					latitudeDeltaH: latitudeDeltaH 
				   longitudeDeltaH: longitudeDeltaH];

	//縦をヒュベニの公式から算出
	latitudeA=latitudeLU;
	latitudeB=latitudeLB;
	latitudeDeltaH=latitudeLU-latitudeLB;
	longitudeDeltaH=longitudeLU-longitudeLB;
	
	double hightMeter=[self hubeny: latitudeB 
						 latitudeA: latitudeA 
					latitudeDeltaH: latitudeDeltaH 
				   longitudeDeltaH: longitudeDeltaH];

	//算出値を表示
	widthMeterPixel=widthMeter/ 300.0;
	hightMeterPixel=hightMeter/ 300.0;
	//getregion = [NSString stringWithFormat:@"pixelSizeMeter:%lf, %lf",widthMeterPixel, hightMeterPixel];
	//NSLog(getregion);

}
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	//アップロード数の初期化
	uploadCount=0;
	modeNumber=0;
	testCount=0;
	mapFirstLook=true;
	
//	mapview.mapType = MKMapTypeHybrid;
	
//	[mapview setShowsUserLocation:YES];
	[mapview setShowsUserLocation:NO];
	
	MKCoordinateRegion zoom;
	//つくチャレコース
	zoom.center.latitude =36.086;
	zoom.center.longitude=140.11;
	//京都大学
//	zoom.center.latitude =35.026262505;
//	zoom.center.longitude=135.78343033;

 	zoom.span.latitudeDelta = 0.0013;
	zoom.span.longitudeDelta = 0.0013;
	[mapview setRegion:zoom animated:NO];

	// CLLocationManagerのインスタンスを作成
	locationManager = [[CLLocationManager alloc] init];
	if ([locationManager locationServicesEnabled]) {
		// ロケーションサービスが利用できる場合
		locationManager.delegate = self;
		[locationManager startUpdatingLocation];
		[locationManager startUpdatingHeading];
	} else {
		// ロケーションサービスが利用できない場合
	}

	//ピクセルサイズの計算
	[self calcPixel];

	//アノテーションの追加
	[self addSomeAnnotations:@"GPS_LOG"];
	
	//ピッカーの用意
	picker.delegate=self;
	picker.hidden=YES;
	
//	picker2.delegate=self;
//	picker2.hidden=YES;

    [super viewDidLoad];
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

- (void)dealloc {
//	[mapview release];
    [super dealloc];
}

- (IBAction)switchButton:(id)sender{
	if([switchState isOn]){
		[locationManager startUpdatingLocation];
	}else{
		[locationManager stopUpdatingLocation];
	}
}

- (void)locationManager:(CLLocationManager *)manager didUpdateHeading:(CLHeading *)newHeading {
	NSString* heading = [NSString stringWithFormat:@"%3.3f",newHeading.trueHeading];
	[compassLabel setText:heading];
//	NSLog(heading);
}

- (void)locationManager:(CLLocationManager *)manager didUpdateToLocation:(CLLocation *)newLocation fromLocation:(CLLocation *)oldLocation {
	// 緯度経度取得に成功した場合
//	CLLocationCoordinate2D coordinate = newLocation.coordinate;
	
	// 取得した座標を中心に地図を表示
//	[mapview setCenterCoordinate:coordinate animated:NO];
	
	// 縮尺を設定
//	if(mapFirstLook){
//		MKCoordinateRegion zoom = mapview.region;
//		zoom.span.latitudeDelta = 0.0025;
//		zoom.span.longitudeDelta = 0.0025;
//		mapFirstLook=false;
//		[mapview setRegion:zoom animated:YES];
////	}		
	
	MKCoordinateRegion zoom;
	zoom.center.latitude =36.086;
	zoom.center.longitude=140.11;
	
 	zoom.span.latitudeDelta = 0.0013;
	zoom.span.longitudeDelta = 0.0013;
	[mapview setRegion:zoom animated:NO];
}

- (void)locationManager:(CLLocationManager *)manager didFailWithError:(NSError *)error{
	// 緯度経度取得に失敗した場合
}

- (IBAction)modeButtonTouchDown:(id)sender{
	modeNumber++;
	if(modeNumber%3==0){
		mapview.mapType = MKMapTypeStandard;
		[modeLabel setText:@"standard"];
	}else if(modeNumber%3==1){
		mapview.mapType = MKMapTypeSatellite;
		[modeLabel setText:@"Satellite"];
	}else{
		mapview.mapType = MKMapTypeHybrid;
		[modeLabel setText:@"Hybrid"];
	}
}

- (IBAction)button0:(id)sender{
	if([switchState2 isOn]){
		//地図系と描画系のビューを入れ替える
		[self.view exchangeSubviewAtIndex:1 withSubviewAtIndex:0];
		
		//1ピクセルが何mかを計算する
		[self calcPixel];

		//waypointdataを空にする。
		logWayPointNorthArray = nil;
		logWayPointEastArray = nil;
		imageview.testLogWayPointEastArray=nil;
		imageview.testLogWayPointNorthArray=nil;

		int row = [picker selectedRowInComponent:0];  

		if(row==0)	[self addSomeAnnotations:@"GPS_LOG"];
		if(row==1)	[self addSomeAnnotations:@"GPS_LOG2"];
		if(row==2)	[self addSomeAnnotations:@"GPS_LOG3"];
		
		[imageview setNeedsDisplay];
//		[mapview setRegion:zoom animated:YES];
		
	}else{
		[self.view exchangeSubviewAtIndex:0 withSubviewAtIndex:1];
	}
}

- (IBAction)saveViewsAndText:(id)sender {
	imageview.alpha=1.0f;
	
    CGRect screenRect = [[UIScreen mainScreen] bounds];
    UIGraphicsBeginImageContext(screenRect.size);
	CGSize ss={300,300};
	UIGraphicsBeginImageContext(ss);
	
    CGContextRef ctx = UIGraphicsGetCurrentContext();
    [[UIColor whiteColor] set];
    CGContextFillRect(ctx, screenRect);

    //領域イメージの保存
	[self.imageview.layer renderInContext:ctx]; 
    UIImage *screenImage = UIGraphicsGetImageFromCurrentImageContext();
    UIImageWriteToSavedPhotosAlbum(screenImage, nil, nil, nil);
	NSData *imageData = UIImagePNGRepresentation(screenImage);
	NSString *filePath = [NSString stringWithFormat:@"%@%@" ,NSHomeDirectory() , @"/Documents/hoge.png"];

	[imageData writeToFile:filePath atomically:YES];
	
	imageview.alpha=0.5f;
	
    //地図イメージの保存
	[self.mapview.layer renderInContext:ctx]; 
    screenImage = UIGraphicsGetImageFromCurrentImageContext();
    UIImageWriteToSavedPhotosAlbum(screenImage, nil, nil, nil);
    UIGraphicsEndImageContext();	
	
	imageData = UIImagePNGRepresentation(screenImage);
	filePath = [NSString stringWithFormat:@"%@%@" ,NSHomeDirectory() , @"/Documents/map.png"];
	
	[imageData writeToFile:filePath atomically:YES];
	
	//ピクセル角度差をテキストファイルに保存
	//テキストのファイルパスを決定
	NSString* path = [NSString stringWithFormat:@"%@%@" ,NSHomeDirectory() , @"/Documents/pixel.txt"];

	NSData* data;
	NSString* test=[NSString stringWithFormat:@"%lf,%lf",widthMeterPixel,hightMeterPixel];
	data=[test dataUsingEncoding:NSUTF8StringEncoding];
//	NSLog(test);
	
	[data writeToFile:path atomically:YES];
	
}

-(void)progress:(NSNumber*)amount{
	activeMark.progress+=[amount floatValue];
	
}

- (NSString*) makeFileName:(NSString*)fileNameOriginal {
	//regionイメージのアップロード
	//ファイル名を作成
	  NSString* fileNameWithCountMade;
	if(uploadCount<10){
		fileNameWithCountMade =[NSString stringWithFormat:@"%@0%d",fileNameOriginal, uploadCount];
	}else{
		fileNameWithCountMade =[NSString stringWithFormat:@"%@%d",fileNameOriginal, uploadCount];
	}
//	NSLog(fileNameWithCountMade);
	return fileNameWithCountMade;

}
// POSTでアップロードする。
-(IBAction) upload:(id)sender{
	activeMark.progress=0.0f;
	[activeMark setHidden:false];
	
	imageview.alpha=1.0f;
	
    CGRect screenRect = [[UIScreen mainScreen] bounds];
    UIGraphicsBeginImageContext(screenRect.size);
	CGSize ss={300,300};
	UIGraphicsBeginImageContext(ss);
	
    CGContextRef ctx = UIGraphicsGetCurrentContext();
    [[UIColor whiteColor] set];
    CGContextFillRect(ctx, screenRect);

	//プログレスバーの更新
	[self performSelectorInBackground:@selector(progress:) withObject:[NSNumber numberWithFloat:0.1f]];
	[NSThread sleepForTimeInterval:0.1f];
	
    //領域イメージの保存
	[self.imageview.layer renderInContext:ctx]; 
    UIImage *screenImage = UIGraphicsGetImageFromCurrentImageContext();
    UIImageWriteToSavedPhotosAlbum(screenImage, nil, nil, nil);
	NSData *imageData = UIImagePNGRepresentation(screenImage);
	NSString *filePath = [NSString stringWithFormat:@"%@%@" ,NSHomeDirectory() , @"/Documents/hoge.png"];
	
	[imageData writeToFile:filePath atomically:YES];
	
	imageview.alpha=0.5f;
	
	//プログレスバーの更新
	[self performSelectorInBackground:@selector(progress:) withObject:[NSNumber numberWithFloat:0.1f]];
	[NSThread sleepForTimeInterval:0.1f];
		
    //地図イメージの保存
	[self.mapview.layer renderInContext:ctx]; 
    screenImage = UIGraphicsGetImageFromCurrentImageContext();
    UIImageWriteToSavedPhotosAlbum(screenImage, nil, nil, nil);
    UIGraphicsEndImageContext();	
	
	imageData = UIImagePNGRepresentation(screenImage);
	filePath = [NSString stringWithFormat:@"%@%@" ,NSHomeDirectory() , @"/Documents/map.png"];
	
	[imageData writeToFile:filePath atomically:YES];
	
	//プログレスバーの更新
	[self performSelectorInBackground:@selector(progress:) withObject:[NSNumber numberWithFloat:0.1f]];
	[NSThread sleepForTimeInterval:0.1f];
	
	
	//ピクセル角度差をテキストファイルに保存
	//テキストのファイルパスを決定
	NSString* path = [NSString stringWithFormat:@"%@%@" ,NSHomeDirectory() , @"/Documents/pixel.txt"];
	
	NSData* data;
	NSString* test=[NSString stringWithFormat:@"%lf,%lf",widthMeterPixel,hightMeterPixel];
	data=[test dataUsingEncoding:NSUTF8StringEncoding];
//	NSLog(test);
	
	[data writeToFile:path atomically:YES];
	
	//プログレスバーの更新
	[self performSelectorInBackground:@selector(progress:) withObject:[NSNumber numberWithFloat:0.1f]];
	[NSThread sleepForTimeInterval:0.3f];
	
	//ファイル名の作成
	NSString* fileNameWithCount=[self makeFileName:@"region"];
//	NSLog(fileNameWithCount);
	
	// アップロード先URL
	NSString * urlInputPath;
	urlInputPath=[urlSt text];
	NSString *urlStr = [NSString stringWithFormat:@"http://%@/temp/upload.php",urlInputPath];
	//---------------------------->> 文字列データの作成
	NSArray *stringKeys = [[NSArray alloc] initWithObjects:@"upload", @"dummy",nil];
	NSArray *stringValues = [[NSArray alloc] initWithObjects:fileNameWithCount, @"dum", nil];	
	NSDictionary *stringDict = [[NSDictionary alloc] initWithObjects:stringValues forKeys:stringKeys];
	
	//---------------------------->> バイナリデータの作成
	filePath = [NSString stringWithFormat:@"%@%@" ,NSHomeDirectory() , @"/Documents/hoge.png"];
	NSArray *binaryKeys = [[NSArray alloc] initWithObjects:@"data", @"orgName", @"postName", nil];
	NSArray *binaryValues = [[NSArray alloc] initWithObjects:(NSData *)[self getUploadFile], filePath, @"pngFile", nil];
	NSDictionary *binaryDict = [[NSDictionary alloc] initWithObjects:binaryValues forKeys:binaryKeys];
	
	NSArray *binaries = [[NSArray alloc] initWithObjects:binaryDict, nil];
	MultipartPostHelper *postHelper = [[MultipartPostHelper alloc] init:urlStr];
	// バイナリデータの追加
	[postHelper setBinaryValues:binaries];
	// 文字データの追加
	[postHelper setStringValues:stringDict];
	//プログレスバーの更新
	[self performSelectorInBackground:@selector(progress:) withObject:[NSNumber numberWithFloat:0.1f]];
	[NSThread sleepForTimeInterval:0.1f];
	
	// 送信処理
	NSString *res = [postHelper send];
	// 送信先から返されるデータをNSLogで表示
//	NSLog(res);
	//プログレスバーの更新
	[self performSelectorInBackground:@selector(progress:) withObject:[NSNumber numberWithFloat:0.1f]];
	[NSThread sleepForTimeInterval:0.1f];
	
	//地図イメージのアップロード
	//ファイル名の作成
	fileNameWithCount=[self makeFileName:@"map"];
//	NSLog(fileNameWithCount);

	// アップロード先URL
//	urlStr = @"http://www.satolab.org/temp/upload.php";
	//---------------------------->> 文字列データの作成
	stringKeys = [[NSArray alloc] initWithObjects:@"upload", @"dummy",nil];
	stringValues = [[NSArray alloc] initWithObjects:fileNameWithCount, @"dum", nil];	
	stringDict = [[NSDictionary alloc] initWithObjects:stringValues forKeys:stringKeys];
	
	//---------------------------->> バイナリデータの作成
	filePath = [NSString stringWithFormat:@"%@%@" ,NSHomeDirectory() , @"/Documents/map.png"];
	binaryKeys = [[NSArray alloc] initWithObjects:@"data", @"orgName", @"postName", nil];
	binaryValues = [[NSArray alloc] initWithObjects:(NSData *)[self getUploadMapFile], filePath, @"pngFile", nil];
	binaryDict = [[NSDictionary alloc] initWithObjects:binaryValues forKeys:binaryKeys];
	binaries = [[NSArray alloc] initWithObjects:binaryDict, nil];
	postHelper = [[MultipartPostHelper alloc] init:urlStr];
	// バイナリデータの追加
	[postHelper setBinaryValues:binaries];
	// 文字データの追加
	[postHelper setStringValues:stringDict];
	//プログレスバーの更新
	[self performSelectorInBackground:@selector(progress:) withObject:[NSNumber numberWithFloat:0.1f]];
	[NSThread sleepForTimeInterval:0.1f];
	
	// 送信処理
	res = [postHelper send];
	// 送信先から返されるデータをNSLogで表示
//	NSLog(res);
	//プログレスバーの更新
	[self performSelectorInBackground:@selector(progress:) withObject:[NSNumber numberWithFloat:0.1f]];
	[NSThread sleepForTimeInterval:0.1f];
	
	//ピクセルデータのアップロード
	//ファイル名の作成
	fileNameWithCount=[self makeFileName:@"pixel"];
//	NSLog(fileNameWithCount);

	// アップロード先URL
//	urlStr = @"http://www.satolab.org/temp/upload.php";
	//---------------------------->> 文字列データの作成
	stringKeys = [[NSArray alloc] initWithObjects:@"upload", @"dummy",nil];
	stringValues = [[NSArray alloc] initWithObjects:fileNameWithCount, @"dum", nil];	
	stringDict = [[NSDictionary alloc] initWithObjects:stringValues forKeys:stringKeys];

	//---------------------------->> バイナリデータの作成
	filePath = [NSString stringWithFormat:@"%@%@" ,NSHomeDirectory() , @"/Documents/pixel.txt"];
	binaryKeys = [[NSArray alloc] initWithObjects:@"data", @"orgName", @"postName", nil];
	binaryValues = [[NSArray alloc] initWithObjects:(NSData *)[self getUploadPixelFile], filePath, @"txtFile", nil];
	binaryDict = [[NSDictionary alloc] initWithObjects:binaryValues forKeys:binaryKeys];	
	binaries = [[NSArray alloc] initWithObjects:binaryDict, nil];
	postHelper = [[MultipartPostHelper alloc] init:urlStr];
	// バイナリデータの追加
	[postHelper setBinaryValues:binaries];
	// 文字データの追加
	[postHelper setStringValues:stringDict];
	//プログレスバーの更新
	[self performSelectorInBackground:@selector(progress:) withObject:[NSNumber numberWithFloat:0.1f]];
	[NSThread sleepForTimeInterval:0.1f];
	
	// 送信処理
	res = [postHelper send];
	// 送信先から返されるデータをNSLogで表示
	//NSLog(res);
	//プログレスバーの更新
	[self performSelectorInBackground:@selector(progress:) withObject:[NSNumber numberWithFloat:0.1f]];
	[NSThread sleepForTimeInterval:0.1f];
	
	[activeMark setHidden:true];
	
	//アップロード数を増やす
	uploadCount++;
}
/**
 * アップロードするファイルをNSDataとして取得する
 */
-(NSData *)getUploadFile
{
	//	NSString *dataPath = [[NSBundle mainBundle] pathForResource:@"hoge" ofType:@"png"];
	NSString *filePath = [NSString stringWithFormat:@"%@%@" ,NSHomeDirectory() , @"/Documents/hoge.png"];
	NSFileManager *fm = [NSFileManager defaultManager];
	NSData *data;
	//	if([fm fileExistsAtPath:dataPath])
	if([fm fileExistsAtPath:filePath])
	{
		//		NSFileHandle *handle = [NSFileHandle fileHandleForReadingAtPath:dataPath];
		NSFileHandle *handle = [NSFileHandle fileHandleForReadingAtPath:filePath];
		data = [handle readDataToEndOfFile];
		[handle closeFile];
	}
	return data;
}
/**
 * アップロードするファイルをNSDataとして取得する
 */
-(NSData *)getUploadMapFile
{
	//	NSString *dataPath = [[NSBundle mainBundle] pathForResource:@"hoge" ofType:@"png"];
	NSString *filePath = [NSString stringWithFormat:@"%@%@" ,NSHomeDirectory() , @"/Documents/map.png"];
	NSFileManager *fm = [NSFileManager defaultManager];
	NSData *data;
	//	if([fm fileExistsAtPath:dataPath])
	if([fm fileExistsAtPath:filePath])
	{
		//		NSFileHandle *handle = [NSFileHandle fileHandleForReadingAtPath:dataPath];
		NSFileHandle *handle = [NSFileHandle fileHandleForReadingAtPath:filePath];
		data = [handle readDataToEndOfFile];
		[handle closeFile];
	}
	return data;
}
/**
 * アップロードするファイルをNSDataとして取得する
 */
-(NSData *)getUploadPixelFile
{
	//	NSString *dataPath = [[NSBundle mainBundle] pathForResource:@"hoge" ofType:@"png"];
	NSString *filePath = [NSString stringWithFormat:@"%@%@" ,NSHomeDirectory() , @"/Documents/pixel.txt"];
	NSFileManager *fm = [NSFileManager defaultManager];
	NSData *data;
	//	if([fm fileExistsAtPath:dataPath])
	if([fm fileExistsAtPath:filePath])
	{
		//		NSFileHandle *handle = [NSFileHandle fileHandleForReadingAtPath:dataPath];
		NSFileHandle *handle = [NSFileHandle fileHandleForReadingAtPath:filePath];
		data = [handle readDataToEndOfFile];
		[handle closeFile];
	}
	return data;
}

/**
 * アップロードするファイルをNSDataとして取得する
 */
-(NSData *)getUploadTestFile
{
	//	NSString *dataPath = [[NSBundle mainBundle] pathForResource:@"hoge" ofType:@"png"];
	NSString *filePath = [NSString stringWithFormat:@"%@%@" ,NSHomeDirectory() , @"/Documents/test.txt"];
	NSFileManager *fm = [NSFileManager defaultManager];
	NSData *data;
	//	if([fm fileExistsAtPath:dataPath])
	if([fm fileExistsAtPath:filePath])
	{
		//		NSFileHandle *handle = [NSFileHandle fileHandleForReadingAtPath:dataPath];
		NSFileHandle *handle = [NSFileHandle fileHandleForReadingAtPath:filePath];
		data = [handle readDataToEndOfFile];
		[handle closeFile];
	}
	return data;
}

-(IBAction)testAction:(id)sender{
	
	NSString* path = [NSString stringWithFormat:@"%@%@" ,NSHomeDirectory() , @"/Documents/test.txt"];
	
	NSData* data;
	NSString* test=[NSString stringWithFormat:@"%d", testCount];
	data=[test dataUsingEncoding:NSUTF8StringEncoding];
	//	NSLog(test);
	
	[data writeToFile:path atomically:YES];
	
	//ピクセルデータのアップロード
	// アップロード先URL
	NSString* urlStr = @"http://www.satolab.org/temp/upload.php";
	//---------------------------->> 文字列データの作成
	NSArray* stringKeys = [[NSArray alloc] initWithObjects:@"upload", @"dummy",nil];
	NSArray* stringValues = [[NSArray alloc] initWithObjects:@"test", @"dum", nil];	
	NSDictionary* stringDict = [[NSDictionary alloc] initWithObjects:stringValues forKeys:stringKeys];
	
	//---------------------------->> バイナリデータの作成
	NSString* filePath = [NSString stringWithFormat:@"%@%@" ,NSHomeDirectory() , @"/Documents/test.txt"];
	NSArray* binaryKeys = [[NSArray alloc] initWithObjects:@"data", @"orgName", @"postName", nil];
	NSArray* binaryValues = [[NSArray alloc] initWithObjects:(NSData *)[self getUploadTestFile], filePath, @"txtFile", nil];
	NSDictionary* binaryDict = [[NSDictionary alloc] initWithObjects:binaryValues forKeys:binaryKeys];	
	NSArray* binaries = [[NSArray alloc] initWithObjects:binaryDict, nil];
	MultipartPostHelper* postHelper = [[MultipartPostHelper alloc] init:urlStr];
	// バイナリデータの追加
	[postHelper setBinaryValues:binaries];
	// 文字データの追加
	[postHelper setStringValues:stringDict];
	
	// 送信処理
	NSString* res = [postHelper send];
	// 送信先から返されるデータをNSLogで表示
	NSLog(res);
	
	[postHelper dealloc];
	
	testCount++;
}


- (MKAnnotationView*)mapView:(MKMapView*)mapView viewForAnnotation:(id <MKAnnotation>)annotation {

	MKPinAnnotationView *annotationView = [[MKPinAnnotationView alloc] initWithAnnotation:annotation reuseIdentifier:@"test"];
	
	[annotationView setPinColor:MKPinAnnotationColorGreen];
	[annotationView setCanShowCallout:YES];
	[annotationView setAnimatesDrop:YES];
	[annotationView setRightCalloutAccessoryView:[UIButton buttonWithType:UIButtonTypeDetailDisclosure]];
	
	//UIImage *pinImage = [UIImage imageNamed:@"pin-image.png"];
	//[annotationView setImage:pinImage];
	
	annotationView.annotation = annotation;
	
	return annotationView;
}

//アノテーションの追加とログデータの保存
- (void)addSomeAnnotations:(NSString*) filename{
	//ログファイルを開く
	NSBundle* bundle;
	bundle = [NSBundle mainBundle];
	NSString* bundleID;
	bundleID = [bundle bundleIdentifier];
	NSString* path;
	path=[bundle pathForResource:filename ofType:@"csv"];
	NSFileHandle* file;
	file = [NSFileHandle fileHandleForReadingAtPath:path];
	
	//ここではとりあえず全文字（10000字以内）取得	
	NSData* data;
	data =[file readDataOfLength:10000];	//文字数
	NSString* dataSt;
	dataSt= [[[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding] autorelease];

	//ログ用の配列を初期化
	logWayPointNorthArray = [NSMutableArray array];
	logWayPointEastArray = [NSMutableArray array];

	//カンマで分割
	NSString* subSt;
	NSRange range, subrange;
	int length;
	length=[dataSt length];
	range = NSMakeRange(0, length);
	while(range.length>0){
		subrange=[dataSt lineRangeForRange:NSMakeRange(range.location,0)];
		subSt = [dataSt substringWithRange:subrange];
		range.location=NSMaxRange(subrange);
		range.length -=subrange.length;
		
		NSArray* array=[subSt componentsSeparatedByString:@","];
		NSString* dataNSt=[array objectAtIndex:0];
		NSString* dataESt=[array objectAtIndex:1];
		double dataN= [dataNSt doubleValue];
		double dataE= [dataESt doubleValue];
		
		//アノテーションの位置
		CLLocationCoordinate2D locationInAno;
		locationInAno.latitude = dataN;
		locationInAno.longitude = dataE;
		
		//アノテーションの追加
		MyAnnotation *annotation;
		annotation =[[MyAnnotation alloc] initWithCoordinate:locationInAno];		
		[mapview addAnnotation:annotation];
		
		//表示している地図の中心を取得
		double mapCenterNorth=mapview.region.center.latitude;
		double mapCenterEast=mapview.region.center.longitude;
		double mapDeltaNorth = mapview.region.span.latitudeDelta;
		double mapDeltaEast = mapview.region.span.longitudeDelta;
		
		//1ピクセルの角度差
		double mapDeltaNorthPixel=mapDeltaNorth/300.0;
		double mapDeltaEastPixel=mapDeltaEast/300.0;
		double pixelX=150.0+(dataE-mapCenterEast)/mapDeltaEastPixel;
		double pixelY=150.0-(dataN-mapCenterNorth)/mapDeltaNorthPixel;
		
		//配列に保存する
		NSString* insertSt;
		insertSt=[NSString stringWithFormat:@"%lf",pixelX];
		[logWayPointEastArray addObject:insertSt];
		insertSt=[NSString stringWithFormat:@"%lf",pixelY];
		[logWayPointNorthArray addObject:insertSt];
		
//		NSString* temp=[NSString stringWithFormat:@"pixel:%d, %d",(int)pixelX, (int)pixelY];
//		NSLog(temp);
	}
	[file closeFile];
		
	imageview.testLogWayPointEastArray=logWayPointEastArray;
	imageview.testLogWayPointNorthArray=logWayPointNorthArray;
}
@end
