//
//  LRFView.m
//  iPhoneCommTest
//
//  Created by nsato on 09/10/20.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "LRFView.h"
#include <math.h>

#define PI 3.14159263

@implementation LRFView

@synthesize firstTouch;
@synthesize lastTouch;
@synthesize endTouch;
@synthesize currentColor;
@synthesize context;
@synthesize lrfDistanceSt;
@synthesize wayPointArray;

-(BOOL) isMultipleTouchEnabled{
	return true;
}

- (void) touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event{
	UITouch *touch =[touches anyObject];
	firstTouch = [touch locationInView:self];
	lastTouch = [touch locationInView:self];

//	NSValue *test=[NSValue valueWithCGPoint:lastTouch];
	[wayPointArray addObject:[NSValue valueWithCGPoint:lastTouch]];
	[self setNeedsDisplay];
	int countOfArray=[wayPointArray count];
	NSLog([NSString stringWithFormat:@"count: %d",countOfArray]);

//	for(int i=0;i<countOfArray;i++){
//		CGPoint currentPoint = [[wayPointArray objectAtIndex:i] CGPointValue];
//		NSLog([NSString stringWithFormat:@"point: %f, %f",(float)currentPoint.x,(float)currentPoint.y]);
//	}
}

- (void) touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event{
	UITouch *touch =[touches anyObject];
	lastTouch = [touch locationInView:self];
	endTouch.x=-100;
	endTouch.y=-100;
//	[wayPointArray addObject:lastTouch];

	[self setNeedsDisplay];
}


-(void)touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event{
	UITouch *touch =[touches anyObject];
	lastTouch = [touch locationInView:self];
	
//	[wayPointArray addObject:lastTouch];
	
	[self setNeedsDisplay];
}


- (id)initWithFrame:(CGRect)frame {
    if (self = [super initWithFrame:frame]) {
        // Initialization code
		self.backgroundColor = [UIColor whiteColor];
//		myArray = [[NSMutableArray alloc] init];
//		myColorArray = [[NSMutableArray alloc] init];
//		wayPointArray = [[NSMutableArray alloc] init];
		
    }
    return self;
}

-(IBAction)repaintbutton:(id)sender{
//	NSLog(lrfDistanceSt);
	
}

- (void)drawRect:(CGRect)rect {
	
	//context取得
	context =UIGraphicsGetCurrentContext();
	//Lineの太さ
	CGContextSetLineWidth(context, 0.0);
	
	//タッチ点の矩形を作成
	CGRect currentRect = CGRectMake(
									(firstTouch.x > lastTouch.x) ? lastTouch.x : firstTouch.x,
									(firstTouch.y > lastTouch.y) ? lastTouch.y : firstTouch.y,
									fabsf(firstTouch.x - lastTouch.x),
									fabsf(firstTouch.y - lastTouch.y));
	
	self.currentColor=[UIColor colorWithRed:0.0f
									  green:1.0f
									   blue:0.0f
									  alpha:1.0];		
	CGContextSetStrokeColorWithColor(context, currentColor.CGColor);
	CGContextSetFillColorWithColor(context, currentColor.CGColor);
	//コンテキストに追加
//	CGContextAddRect(context, currentRect);
	//実際に描画
//	CGContextDrawPath(context, kCGPathFillStroke);
	
	
	//wayPointを表示
	
	self.currentColor=[UIColor colorWithRed:1.0f
									  green:0.0f
									   blue:1.0f
									  alpha:1.0];		
	CGContextSetStrokeColorWithColor(context, currentColor.CGColor);
	CGContextSetFillColorWithColor(context, currentColor.CGColor);
	
	//矩形データをセット(スタート地点）
	for(int i=0;i<[wayPointArray count];i++){
		
		CGPoint currentPoint = [[wayPointArray objectAtIndex:i] CGPointValue];
//		NSLog([NSString stringWithFormat:@"point: %f, %f",(float)currentPoint.x,(float)currentPoint.y]);
		CGRect wayPoint = CGRectMake(
									 (float)(currentPoint.x)-3,
									 (float)(currentPoint.y)-3,
									 6.0f,
									 6.0f);
		//コンテキストに追加
		CGContextAddRect(context, wayPoint);
		
	}
	
	//実際に描画
	CGContextDrawPath(context, kCGPathFillStroke);
	
	
	

	self.currentColor=[UIColor colorWithRed:1.0f
									  green:0.0f
									   blue:0.0f
									  alpha:1.0];		
	CGContextSetStrokeColorWithColor(context, currentColor.CGColor);
	CGContextSetFillColorWithColor(context, currentColor.CGColor);
	
	//矩形データをセット(スタート地点）
	CGRect startPoint = CGRectMake((int)150-8,(int)150-8,16.0f,16.0f);
	//コンテキストに追加
	CGContextAddRect(context, startPoint);
	//Path作成開始
	CGContextBeginPath(context);
	//Pathの位置設定
	CGContextMoveToPoint(context, 150+3, 150);
	CGContextAddLineToPoint(context, 150, 150-10);
	CGContextAddLineToPoint(context, 150-3, 150);
	CGContextAddLineToPoint(context, 150+3, 150);
	//Pathの描画
	CGContextDrawPath(context, kCGPathFillStroke);
	
	//実際に描画
	CGContextDrawPath(context, kCGPathFillStroke);

	self.currentColor=[UIColor colorWithRed:0.0f
									  green:0.0f
									   blue:1.0f
									  alpha:1.0];		
	CGContextSetStrokeColorWithColor(context, currentColor.CGColor);
	CGContextSetFillColorWithColor(context, currentColor.CGColor);
	
	NSArray* lrfDistanceArray=[lrfDistanceSt componentsSeparatedByString:@","];
	if([lrfDistanceArray count] >170){
		double x=0;
		double y=0;
		for(int i=0;i<[lrfDistanceArray count];i++){
			if([[lrfDistanceArray objectAtIndex:i] floatValue] <5590){
				y=-([[lrfDistanceArray objectAtIndex:i] floatValue]*cos(3.14169563*2.0/180.0*i))/40.0+150;
				x=-([[lrfDistanceArray objectAtIndex:i] floatValue]*sin(3.14169563*2.0/180.0*i))/40.0+150;
				//			NSString *disp = [NSString stringWithFormat:@"lrf:%f,%f",x,y];
				//			NSLog(disp);
				//矩形データをセット
				CGRect lrfPoint = CGRectMake((int)x-2,(int)y-2,4.0f,4.0f);
				//コンテキストに追加
				CGContextAddRect(context, lrfPoint);
			}
		}
	}
	//実際に描画
	CGContextDrawPath(context, kCGPathFillStroke);
	
}



- (void)dealloc {
    [super dealloc];
}

@end
